Index: code/branches/pickup/src/orxonox/pickup/ModifierPickup.cc
===================================================================
--- code/branches/pickup/src/orxonox/pickup/ModifierPickup.cc	(revision 5815)
+++ code/branches/pickup/src/orxonox/pickup/ModifierPickup.cc	(revision 5902)
@@ -43,6 +43,8 @@
 
     /**
-        @brief Constructor. Registers the ModifierPickup.
-        @param creator Pointer to the object which created this item.
+    @brief
+        Constructor. Registers the ModifierPickup.
+    @param creator
+        Pointer to the object which created this item.
     */
     ModifierPickup::ModifierPickup(BaseObject* creator) : PassiveItem(creator)
@@ -52,13 +54,23 @@
         this->duration_ = 0.0f;
     }
-    //! Deconstructor.
+
+    /**
+    @brief
+        Destructor.
+    */
     ModifierPickup::~ModifierPickup()
     {
-    }
-    /**
-        @brief Method for loading information from a level file.
-        @param element XMLElement from which to read the data.
-        @param mode XMLPort mode to use.
-    */
+        
+    }
+
+    /**
+    @brief
+        Method for loading information from a level file.
+    @param element
+        XMLElement from which to read the data.
+    @param mode
+        XMLPort mode to use.
+    */
+    //TODO: Comments: params can probably be ommitted. 
     void ModifierPickup::XMLPort(Element& element, XMLPort::Mode mode)
     {
@@ -73,13 +85,16 @@
         XMLPortParamTemplate(ModifierPickup, "accelerationMulti", setMultiplicativeAcceleration, getMultiplicativeAcceleration, element, mode, float);
     }
-    /**
-        @brief
-            Invoked when a pawn picks up the pickup.
-
-            Adds the modifiers to the pawn and sets a timer (if effect is limited)
-            if the pickup could be added to the pawn's PickupCollection.
-
-        @param pawn Pawn which picked up the pickup.
-        @return Returns whether the pickup was able to be added to the pawn.
+
+    /**
+    @brief
+        Invoked when a pawn picks up the pickup.
+
+        Adds the modifiers to the pawn and sets a timer (if effect is limited)
+        if the pickup could be added to the pawn's PickupCollection.
+
+    @param pawn
+        Pawn which picked up the pickup.
+    @return
+        Returns whether the pickup was able to be added to the pawn.
     */
     bool ModifierPickup::pickedUp(Pawn* pawn)
@@ -110,13 +125,16 @@
         return false;
     }
-    /**
-        @brief
-            Invoked when a pawn drops the pickup.
-
-            Removes the modifiers from the pawn if the pickup
-            was successfully removed from it's PickupCollection.
-
-        @param pawn Pawn which dropped the pickup.
-        @return Returns whether the pickup could be removed.
+
+    /**
+    @brief
+        Invoked when a pawn drops the pickup.
+
+        Removes the modifiers from the pawn if the pickup
+        was successfully removed from it's PickupCollection.
+
+    @param pawn
+        Pawn which dropped the pickup.
+    @return 
+        Returns whether the pickup could be removed.
     */
     bool ModifierPickup::dropped(Pawn* pawn)
@@ -145,7 +163,9 @@
         return false;
     }
-    /**
-        @brief Invoked when the timer finished, calls dropped().
-    */
+
+    /**
+    @brief Invoked when the timer finished, calls dropped().
+    */
+    //TODO: Other name for function?
     void ModifierPickup::timerCallback(Pawn* pawn)
     {
@@ -153,8 +173,12 @@
             COUT(2) << "Failed to remove modifier pickup after the timer ran out!" << std::endl;
     }
-    /**
-        @brief Gets the additive modifier of a given type.
-        @param type ModifierType for which to return the modifier.
-        @return Returns the additive modifier for type (or 0 if not exists).
+
+    /**
+    @brief
+        Gets the additive modifier of a given type.
+    @param type
+        ModifierType for which to return the modifier.
+    @return
+        Returns the additive modifier for type (or 0 if not exists).
     */
     float ModifierPickup::getAdditiveModifier(ModifierType::Value type) const
@@ -166,8 +190,12 @@
             return 0.0f;
     }
-    /**
-        @brief Gets the multiplicative modifier of a given type.
-        @param type ModifierType for which to return the modifier.
-        @return Returns the multiplicative modifier for type (or 1 if not exists).
+
+    /**
+    @brief
+        Gets the multiplicative modifier of a given type.
+    @param type
+        ModifierType for which to return the modifier.
+    @return
+        Returns the multiplicative modifier for type (or 1 if not exists).
     */
     float ModifierPickup::getMultiplicativeModifier(ModifierType::Value type) const
@@ -179,8 +207,12 @@
             return 1.0f;
     }
-    /**
-        @brief Gets the additive modifier of a given type.
-        @param type ModifierType for which to return the modifier.
-        @param value The new additive modifier for type.
+
+    /**
+    @brief
+        Gets the additive modifier of a given type.
+    @param type
+        ModifierType for which to return the modifier.
+    @param value
+        The new additive modifier for type.
     */
     void ModifierPickup::setAdditiveModifier(ModifierType::Value type, float value)
@@ -191,8 +223,12 @@
             this->additiveModifiers_[type] = value;
     }
-    /**
-        @brief Gets the multiplicative modifier of a given type.
-        @param type ModifierType for which to return the modifier.
-        @param value The new multiplicative modifier for type.
+
+    /**
+    @brief
+        Gets the multiplicative modifier of a given type.
+    @param type
+        ModifierType for which to return the modifier.
+    @param value
+        The new multiplicative modifier for type.
     */
     void ModifierPickup::setMultiplicativeModifier(ModifierType::Value type, float value)
@@ -203,3 +239,4 @@
             this->multiplicativeModifiers_[type] = value;
     }
+
 }