Index: code/branches/core5/src/libraries/core/GUIManager.cc
===================================================================
--- code/branches/core5/src/libraries/core/GUIManager.cc	(revision 5910)
+++ code/branches/core5/src/libraries/core/GUIManager.cc	(revision 5911)
@@ -101,4 +101,5 @@
         : renderWindow_(renderWindow)
         , resourceProvider_(0)
+        , camera_(NULL)
     {
         using namespace CEGUI;
@@ -174,4 +175,5 @@
     void GUIManager::setCamera(Ogre::Camera* camera)
     {
+        this->camera_ = camera;
         if (camera == NULL)
             this->guiRenderer_->setTargetSceneManager(0);
Index: code/branches/core5/src/libraries/core/GUIManager.h
===================================================================
--- code/branches/core5/src/libraries/core/GUIManager.h	(revision 5910)
+++ code/branches/core5/src/libraries/core/GUIManager.h	(revision 5911)
@@ -71,4 +71,5 @@
 
         void setCamera(Ogre::Camera* camera);
+        Ogre::Camera* getCamera() { return this->camera_; }
 
         static GUIManager* getInstancePtr() { return singletonPtr_s; }
@@ -101,4 +102,5 @@
         CEGUI::Logger*                       ceguiLogger_;      //!< CEGUI's logger to be able to log CEGUI errors in our log
         std::map<std::string, PlayerInfo*>   players_;          //!< Stores the player (owner) for each gui
+        Ogre::Camera*                        camera_;           //!< Camera used to render the scene with the GUI
 
         static GUIManager*                   singletonPtr_s;    //!< Singleton reference to GUIManager
Index: code/branches/core5/src/modules/objects/Planet.cc
===================================================================
--- code/branches/core5/src/modules/objects/Planet.cc	(revision 5910)
+++ code/branches/core5/src/modules/objects/Planet.cc	(revision 5911)
@@ -47,5 +47,5 @@
      * @brief Constructor
      */
-    Planet::Planet(BaseObject* creator): MovableEntity(creator)
+    Planet::Planet(BaseObject* creator) : MovableEntity(creator)
     {
         RegisterObject(Planet);
@@ -64,11 +64,11 @@
     void Planet::tick(float dt)
     {
-        if(!this->isVisible())
+        if (!this->isVisible())
             return;
 
         if (GameMode::showsGraphics())
         {
-            Camera* activeCamera = CameraManager::getInstance().getActiveCamera();
-            if(activeCamera)
+            Camera* activeCamera = this->getScene()->getCameraManager()->getActiveCamera();
+            if (activeCamera)
             {
                 float distance = this->getPosition().distance( activeCamera->getWorldPosition() );
Index: code/branches/core5/src/orxonox/CameraManager.cc
===================================================================
--- code/branches/core5/src/orxonox/CameraManager.cc	(revision 5910)
+++ code/branches/core5/src/orxonox/CameraManager.cc	(revision 5911)
@@ -38,5 +38,4 @@
 #include "core/GUIManager.h"
 #include "core/ObjectList.h"
-#include "core/ScopedSingletonManager.h"
 #include "tools/Shader.h"
 #include "graphics/Camera.h"
@@ -45,23 +44,25 @@
 namespace orxonox
 {
-    CameraManager* CameraManager::singletonPtr_s = 0;
-    ManageScopedSingleton(CameraManager, ScopeID::Graphics, false);
-
-    CameraManager::CameraManager()
-        : viewport_(GraphicsManager::getInstance().getViewport())
+    CameraManager::CameraManager(BaseObject* creator)
+        : BaseObject(creator)
+        , viewport_(GraphicsManager::getInstance().getViewport())
+        , fallbackCamera_(NULL)
     {
-        this->fallbackCamera_ = 0;
+        assert(GameMode::showsGraphics());
     }
 
     CameraManager::~CameraManager()
     {
+        for (std::list<Camera*>::iterator it = this->cameraList_.begin(); it != this->cameraList_.end();)
+            if ((*it)->camera_ == GUIManager::getInstance().getCamera())
+                GUIManager::getInstance().setCamera(NULL);
+
         if (this->fallbackCamera_)
-            this->fallbackCameraScene_->getSceneManager()->destroyCamera(this->fallbackCamera_);
-        GUIManager::getInstance().setCamera(0);
+            this->getScene()->getSceneManager()->destroyCamera(this->fallbackCamera_);
     }
 
     Camera* CameraManager::getActiveCamera() const
     {
-        if (this->cameraList_.size() > 0)
+        if (!this->cameraList_.empty())
             return this->cameraList_.front();
         else
@@ -71,22 +72,16 @@
     void CameraManager::requestFocus(Camera* camera)
     {
-        if (!GameMode::showsGraphics())
-            return;
-
         // notify old camera (if it exists)
-        if (this->cameraList_.size() > 0)
+        if (!this->cameraList_.empty())
             this->cameraList_.front()->removeFocus();
-        else if (this->fallbackCamera_)
-        {
-            this->fallbackCameraScene_->getSceneManager()->destroyCamera(this->fallbackCamera_);
-            this->fallbackCamera_ = 0;
-        }
 
         camera->setFocus();
 
         // make sure we don't add it twice
-        for (std::list<Camera*>::iterator it = this->cameraList_.begin(); it != this->cameraList_.end(); ++it)
+        for (std::list<Camera*>::iterator it = this->cameraList_.begin(); it != this->cameraList_.end();)
             if ((*it) == camera)
-                return;
+                this->cameraList_.erase(it++);
+            else
+                ++it;
 
         // add to list
@@ -96,9 +91,6 @@
     void CameraManager::releaseFocus(Camera* camera)
     {
-        if (!GameMode::showsGraphics())
-            return;
-
         // notify the cam of releasing the focus
-        if (this->cameraList_.front() == camera)
+        if (!this->cameraList_.empty() && this->cameraList_.front() == camera)
         {
             camera->removeFocus();
@@ -106,5 +98,5 @@
 
             // set new focus if possible
-            if (this->cameraList_.size() > 0)
+            if (!this->cameraList_.empty())
                 this->cameraList_.front()->setFocus();
             else
@@ -112,15 +104,10 @@
                 // there are no more cameras, create a fallback
                 if (!this->fallbackCamera_)
-                {
-                    this->fallbackCameraScene_ = camera->getScene();
-                    this->fallbackCamera_ = this->fallbackCameraScene_->getSceneManager()->createCamera(getUniqueNumberString());
-                }
+                    this->fallbackCamera_ = camera->getScene()->getSceneManager()->createCamera(getUniqueNumberString());
                 this->useCamera(this->fallbackCamera_);
             }
         }
         else
-        {
             this->cameraList_.remove(camera);
-        }
     }
 
Index: code/branches/core5/src/orxonox/CameraManager.h
===================================================================
--- code/branches/core5/src/orxonox/CameraManager.h	(revision 5910)
+++ code/branches/core5/src/orxonox/CameraManager.h	(revision 5911)
@@ -41,15 +41,12 @@
 #include <list>
 #include "util/OgreForwardRefs.h"
-#include "util/Singleton.h"
-#include "core/OrxonoxClass.h"
-#include "core/SmartPtr.h"
+#include "core/BaseObject.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport CameraManager : public Singleton<CameraManager>, public OrxonoxClass
+    class _OrxonoxExport CameraManager : public BaseObject
     {
-            friend class Singleton<CameraManager>;
         public:
-            CameraManager();
+            CameraManager(BaseObject* creator);
             ~CameraManager();
 
@@ -61,6 +58,4 @@
             void useCamera(Ogre::Camera* camera);
 
-            static CameraManager* getInstancePtr() { return singletonPtr_s; }
-
         private:
             CameraManager(const CameraManager&); // don't use
@@ -69,7 +64,4 @@
             Ogre::Viewport*       viewport_;
             Ogre::Camera*         fallbackCamera_;
-            SmartPtr<Scene>       fallbackCameraScene_;
-
-            static CameraManager* singletonPtr_s;
     };
 }
Index: code/branches/core5/src/orxonox/Scene.cc
===================================================================
--- code/branches/core5/src/orxonox/Scene.cc	(revision 5910)
+++ code/branches/core5/src/orxonox/Scene.cc	(revision 5911)
@@ -45,4 +45,5 @@
 #include "tools/BulletConversions.h"
 #include "Radar.h"
+#include "CameraManager.h"
 #include "worldentities/WorldEntity.h"
 
@@ -65,4 +66,5 @@
 
             this->radar_ = new Radar();
+            this->cameraManager_ = new CameraManager(this);
         }
         else
@@ -73,4 +75,5 @@
 
             this->radar_ = 0;
+            this->cameraManager_ = 0;
         }
 
@@ -94,5 +97,10 @@
         {
             if (GameMode::showsGraphics())
+            {
+                // Check whether we're still using this scene manager for the GUI
+                if (GUIManager::getInstance().getCamera() && GUIManager::getInstance().getCamera()->getSceneManager() == this->sceneManager_)
+                    GUIManager::getInstance().setCamera(NULL);
                 Ogre::Root::getSingleton().destroySceneManager(this->sceneManager_);
+            }
             else
                 delete this->sceneManager_;
@@ -100,4 +108,7 @@
             if (this->radar_)
                 this->radar_->destroy();
+
+            if (this->cameraManager_)
+                this->cameraManager_->destroy();
 
             this->setPhysicalWorld(false);
Index: code/branches/core5/src/orxonox/Scene.h
===================================================================
--- code/branches/core5/src/orxonox/Scene.h	(revision 5910)
+++ code/branches/core5/src/orxonox/Scene.h	(revision 5911)
@@ -73,4 +73,7 @@
             inline Radar* getRadar()
                 { return this->radar_; }
+
+            inline CameraManager* getCameraManager()
+                { return this->cameraManager_.get(); }
             
             inline virtual uint32_t getSceneID() const { return this->getObjectID(); }
@@ -97,4 +100,5 @@
             bool                     bShadows_;
             Radar*                   radar_;
+            SmartPtr<CameraManager>  cameraManager_;
 
 
Index: code/branches/core5/src/orxonox/graphics/Camera.cc
===================================================================
--- code/branches/core5/src/orxonox/graphics/Camera.cc	(revision 5910)
+++ code/branches/core5/src/orxonox/graphics/Camera.cc	(revision 5911)
@@ -38,4 +38,5 @@
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
+#include "core/GameMode.h"
 #include "Scene.h"
 #include "CameraManager.h"
@@ -49,4 +50,6 @@
         RegisterObject(Camera);
 
+        if (!GameMode::showsGraphics())
+            ThrowException(AbortLoading, "Can't create Camera, no graphics.");
         if (!this->getScene())
             ThrowException(AbortLoading, "Can't create Camera, no scene.");
@@ -117,10 +120,10 @@
     void Camera::requestFocus()
     {
-        CameraManager::getInstance().requestFocus(this);
+        this->getScene()->getCameraManager()->requestFocus(this);
     }
 
     void Camera::releaseFocus()
     {
-        CameraManager::getInstance().releaseFocus(this);
+        this->getScene()->getCameraManager()->releaseFocus(this);
     }
 
@@ -137,5 +140,5 @@
     {
         this->bHasFocus_ = true;
-        CameraManager::getInstance().useCamera(this->camera_);
+        this->getScene()->getCameraManager()->useCamera(this->camera_);
     }
 