Index: trunk/src/lib/collision_detection/cd_engine.cc
===================================================================
--- trunk/src/lib/collision_detection/cd_engine.cc	(revision 5885)
+++ trunk/src/lib/collision_detection/cd_engine.cc	(revision 5915)
@@ -24,5 +24,5 @@
 #include "world_entity.h"
 #include "terrain.h"
-#include "player.h"
+// #include "player.h"
 
 #include "spatial_separation.h"
@@ -119,5 +119,5 @@
     Quadtree* q = this->terrain->ssp->getQuadtree();
 
-    QuadtreeNode* n = q->getQuadtreeFromPosition(this->player->getAbsCoor());
+//    QuadtreeNode* n = q->getQuadtreeFromPosition(this->player->getAbsCoor());
   }
   //sTriangleExt* tri = q->getTriangleFromPosition(this->player->getAbsCoor());
Index: trunk/src/lib/collision_detection/cd_engine.h
===================================================================
--- trunk/src/lib/collision_detection/cd_engine.h	(revision 5885)
+++ trunk/src/lib/collision_detection/cd_engine.h	(revision 5915)
@@ -17,5 +17,5 @@
 class OBBTree;
 class Terrain;
-class Player;
+//class Player;
 
 
@@ -51,5 +51,5 @@
   inline void setEntityList(tList<WorldEntity>* entityList) { this->entityList = entityList; }
   inline void setTerrain(Terrain* terrain) { this->terrain = terrain; }
-  inline void setPlayer(Player* player) { this->player = player; } /* only for debug purposes \todo: delete*/
+  //  inline void setPlayer(Player* player) { this->player = player; } /* only for debug purposes \todo: delete*/
 
   void drawBV(int depth, int drawMode) const;
@@ -79,5 +79,5 @@
 
   Terrain*                terrain;                          //!< this it a ref to the terrain, serving as a ground for all WE
-  Player*                 player;
+//  Player*                 player;
 };
 
Index: trunk/src/lib/coord/p_node.cc
===================================================================
--- trunk/src/lib/coord/p_node.cc	(revision 5885)
+++ trunk/src/lib/coord/p_node.cc	(revision 5915)
@@ -428,4 +428,5 @@
 
   this->bias = bias;
+  this->bRelDirChanged = true;
 }
 
@@ -836,4 +837,5 @@
         glEnd();
       }
+
       /* if we want to draw the children too */
       if (depth == 0) /* -> all of them */
Index: trunk/src/lib/coord/p_node.h
===================================================================
--- trunk/src/lib/coord/p_node.h	(revision 5885)
+++ trunk/src/lib/coord/p_node.h	(revision 5915)
@@ -76,5 +76,5 @@
   inline const Vector& getRelCoor () const { return this->prevRelCoordinate; };
   /** @returns the Relative Coordinate Destination */
-  inline const Vector& getRelCoorSoft2D() const { return (this->toCoordinate)?*this->toCoordinate:this->relCoordinate; };
+  inline const Vector& getRelCoorSoft2D() const { return (this->toCoordinate)? *this->toCoordinate : this->relCoordinate; };
   void setAbsCoor (const Vector& absCoord);
   void setAbsCoor (float x, float y, float z);
@@ -93,5 +93,5 @@
   inline const Quaternion& getRelDir () const { return this->prevRelDirection; };
   /** @returns the Relative Directional Destination */
-  inline const Quaternion& getRelDirSoft2D() const { return (this->toDirection)?*this->toDirection:this->relDirection; };
+  inline const Quaternion& getRelDirSoft2D() const { return (this->toDirection)? *this->toDirection : this->relDirection; };
   /** @returns a Vector pointing into the relative Direction */
   inline Vector getRelDirV() const { return this->prevRelDirection.apply(Vector(0,1,0)); };
@@ -100,9 +100,15 @@
   void setAbsDirSoft(const Quaternion& absDirSoft, float bias = 1.0);
   void setAbsDirSoft(float x, float y, float z, float bias = 1.0);
+  void shiftDir (const Quaternion& shift);
   /** @returns the absolute Direction */
   inline const Quaternion& getAbsDir () const { return this->absDirection; };
   /** @returns a Vector pointing into the absolute Direction */
   inline Vector getAbsDirV() const { return this->absDirection.apply(Vector(0,1,0)); };
-  void shiftDir (const Quaternion& shift);
+  /** @returns A Vector pointing into the forward direction (X) of the Node */
+  inline Vector getAbsDirX() const { return this->absDirection.apply(Vector(1,0,0)); };
+  /** @returns A Vector pointing into the upward direction (Y) of the Node */
+  inline Vector getAbsDirY() const { return this->absDirection.apply(Vector(0,1,0)); };
+  /** @returns A Vector pointing into the right direction (Z) of the Node */
+  inline Vector getAbsDirZ() const { return this->absDirection.apply(Vector(0,0,1)); };
 
   /** @returns the Speed of the Node */
Index: trunk/src/lib/event/key_mapper.cc
===================================================================
--- trunk/src/lib/event/key_mapper.cc	(revision 5885)
+++ trunk/src/lib/event/key_mapper.cc	(revision 5915)
@@ -21,8 +21,11 @@
 #include "key_mapper.h"
 
+#include "event_def.h"
+
 #include "globals.h"
 #include "ini_parser.h"
 #include "key_names.h"
 #include "debug.h"
+
 
 using namespace std;
@@ -191,14 +194,14 @@
       {
         if( index[0] == 0)
-	{
+        {
           *map[i].pValue = index[1];
           PRINTF(4)("Mapping %s to '%s' (id %i)\n", name, SDLKToKeyname(index[1]), index[1]);
           break;
-	}
-	else { 
+        }
+        else {
           *map[i].pValue = index[1];
           PRINTF(4)("Mapping %s to '%s' (id %i)\n", name, SDLBToButtonname(index[1]), index[1]);
           break;
-	}
+        }
       }
     }
Index: trunk/src/lib/event/key_mapper.h
===================================================================
--- trunk/src/lib/event/key_mapper.h	(revision 5885)
+++ trunk/src/lib/event/key_mapper.h	(revision 5915)
@@ -10,5 +10,5 @@
 
 #include "base_object.h"
-#include "event_def.h"
+//#include "event_def.h"
 
 class IniParser;
@@ -66,5 +66,5 @@
 
  private:
-  Sint32     coord[2];              //!< temp place to save variables in nameToIndex() function
+  int         coord[2];              //!< temp place to save variables in nameToIndex() function
 };
 
Index: trunk/src/lib/lang/base_object.cc
===================================================================
--- trunk/src/lib/lang/base_object.cc	(revision 5885)
+++ trunk/src/lib/lang/base_object.cc	(revision 5915)
@@ -112,6 +112,6 @@
   else if (classID & CL_MASK_SUBSUPER_CLASS)
   {
-    if (likely(((this->classID & CL_MASK_SUBSUPER_CLASS_ID) == (this->classID & CL_MASK_SUBSUPER_CLASS_ID)) &&
-        this->classID & classID & CL_MASK_SUBSUPER_CLASS_ID2))
+    if (likely(((this->classID & CL_MASK_SUBSUPER_CLASS_IDA) == (this->classID & CL_MASK_SUBSUPER_CLASS_IDA)) &&
+        this->classID & classID & CL_MASK_SUBSUPER_CLASS_IDB))
       return true;
   }
Index: trunk/src/lib/lang/class_list.h
===================================================================
--- trunk/src/lib/lang/class_list.h	(revision 5885)
+++ trunk/src/lib/lang/class_list.h	(revision 5915)
@@ -46,4 +46,6 @@
     static bool                           exists(const BaseObject* object, ClassID classID = CL_NULL);
 
+    void                                  sendBack(std::list<BaseObject*>::const_iterator it);
+
     static void                           whatIs(const BaseObject* object);
 
@@ -51,5 +53,5 @@
     static long                           StringToID(const char* className);
     static void                           debug(unsigned int debugLevel = 0, long classID = CL_NULL);
-    static void                           debugS(const char* className = 0x0, unsigned int debugLevel = 0);
+    static void                           debugS(const char* className = NULL, unsigned int debugLevel = 0);
 
     inline bool                           operator==(ClassID classID) { return (this->classID == classID); };
Index: trunk/src/lib/sound/sound_engine.cc
===================================================================
--- trunk/src/lib/sound/sound_engine.cc	(revision 5885)
+++ trunk/src/lib/sound/sound_engine.cc	(revision 5915)
@@ -281,9 +281,13 @@
 
   // INITIALIZING THE DEVICE:
+#ifndef AL_VERSION_1_1
   ALubyte deviceName[] =
+#else
+  ALCchar deviceName[] =
+#endif
 #ifdef __WIN32__
-      "native";
+      "Direct3D";
 #else
-      "'( ( devices '( native arts null ) ) )";
+      "'( ( devices '( native null ) ) )";
 #endif
   //