Index: branches/collision_detection/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- branches/collision_detection/src/lib/collision_detection/obb_tree_node.cc	(revision 5884)
+++ branches/collision_detection/src/lib/collision_detection/obb_tree_node.cc	(revision 5920)
@@ -98,5 +98,5 @@
   PRINTF(3)("\n==============================Creating OBB Tree Node==================\n");
   PRINT(3)(" OBB Tree Infos: \n");
-  PRINT(3)("\tDepth: %i \n\tTree Index: %i \n\tNumber of Vertices: %i\n", depth, treeIndex, length);
+  PRINT(3)("\tDepth: %i \n\tTree Index: %i \n\tNumber of Triangles: %i\n", depth, treeIndex, length);
   this->depth = depth;
 
@@ -290,39 +290,39 @@
 
   /* get a bad bounding box axis */
-  halfLength[0] = -1.0f;
-  for( int j = 0; j < length; ++j)
-  {
-    for( int i = 0; i < 3; ++i)
-    {
-      tmpVec = (sVec3D*)(&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]]);
-      tmpLength = fabs(p0.distancePoint(*tmpVec));
-      if( tmpLength > halfLength[0])
-        halfLength[0] = tmpLength;
-    }
-  }
-
-  halfLength[1] = -1.0f;
-  for( int j = 0; j < length; ++j)
-  {
-    for( int i = 0; i < 3; ++i)
-    {
-      tmpVec = (sVec3D*)(&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]]);
-      tmpLength = fabs(p0.distancePoint(*tmpVec));
-      if( tmpLength > halfLength[1])
-        halfLength[1] = tmpLength;
-    }
-  }
-
-  halfLength[2] = -1.0f;
-  for( int j = 0; j < length; ++j)
-  {
-    for( int i = 0; i < 3; ++i)
-    {
-      tmpVec = (sVec3D*)(&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]]);
-      tmpLength = fabs(p0.distancePoint(*tmpVec));
-      if( tmpLength > halfLength[2])
-        halfLength[2] = tmpLength;
-    }
-  }
+//   halfLength[0] = -1.0f;
+//   for( int j = 0; j < length; ++j)
+//   {
+//     for( int i = 0; i < 3; ++i)
+//     {
+//       tmpVec = (sVec3D*)(&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]]);
+//       tmpLength = fabs(p0.distancePoint(*tmpVec));
+//       if( tmpLength > halfLength[0])
+//         halfLength[0] = tmpLength;
+//     }
+//   }
+//
+//   halfLength[1] = -1.0f;
+//   for( int j = 0; j < length; ++j)
+//   {
+//     for( int i = 0; i < 3; ++i)
+//     {
+//       tmpVec = (sVec3D*)(&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]]);
+//       tmpLength = fabs(p0.distancePoint(*tmpVec));
+//       if( tmpLength > halfLength[1])
+//         halfLength[1] = tmpLength;
+//     }
+//   }
+//
+//   halfLength[2] = -1.0f;
+//   for( int j = 0; j < length; ++j)
+//   {
+//     for( int i = 0; i < 3; ++i)
+//     {
+//       tmpVec = (sVec3D*)(&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]]);
+//       tmpLength = fabs(p0.distancePoint(*tmpVec));
+//       if( tmpLength > halfLength[2])
+//         halfLength[2] = tmpLength;
+//     }
+//   }
 
 
@@ -382,6 +382,7 @@
 
   /* calculate the real centre of the body by using the axis length */
-  float centerOffset[3];
-  float newHalfLength[3];
+  float               centerOffset[3];
+  float               newHalfLength[3];
+
   for(int i = 0; i < 3; ++i)
   {
@@ -392,7 +393,7 @@
   }
   PRINTF(3)("\n");
-  PRINT(3)("\tmax: %11.2f, \tmin: %11.2f\n", maxLength[0], minLength[0]);
-  PRINT(3)("\tmax: %11.2f, \tmin: %11.2f\n", maxLength[1], minLength[1]);
-  PRINT(3)("\tmax: %11.2f, \tmin: %11.2f\n", maxLength[2], minLength[2]);
+  PRINT(3)("\tAxis Length x: %f (max: %11.2f, \tmin: %11.2f)\n", halfLength[0], maxLength[0], minLength[0]);
+  PRINT(3)("\tAxis Length x: %f (max: %11.2f, \tmin: %11.2f)\n", halfLength[1], maxLength[1], minLength[1]);
+  PRINT(3)("\tAxis Length x: %f (max: %11.2f, \tmin: %11.2f)\n", halfLength[2], maxLength[2], minLength[2]);
 
 
@@ -450,4 +451,7 @@
   const float*             b;                                    //!< triangle  edge b
   const float*             c;                                    //!< triangle  edge c
+
+
+  ./* find the center of the box */
 
   this->separationPlane = Plane(box.axis[longestAxisIndex], box.center);