Index: code/branches/core5/src/libraries/core/GUIManager.h
===================================================================
--- code/branches/core5/src/libraries/core/GUIManager.h	(revision 5924)
+++ code/branches/core5/src/libraries/core/GUIManager.h	(revision 5925)
@@ -102,5 +102,5 @@
         CEGUI::Logger*                       ceguiLogger_;      //!< CEGUI's logger to be able to log CEGUI errors in our log
         std::map<std::string, PlayerInfo*>   players_;          //!< Stores the player (owner) for each gui
-        Ogre::Camera*                        camera_;           //!< Camera used to render the scene with the 
+        Ogre::Camera*                        camera_;           //!< Camera used to render the scene with the GUI
 
         static GUIManager*                   singletonPtr_s;    //!< Singleton reference to GUIManager
Index: code/branches/core5/src/libraries/core/GraphicsManager.cc
===================================================================
--- code/branches/core5/src/libraries/core/GraphicsManager.cc	(revision 5924)
+++ code/branches/core5/src/libraries/core/GraphicsManager.cc	(revision 5925)
@@ -361,6 +361,5 @@
 
         // Render frame
-        if( this->viewport_->getCamera() )
-            ogreRoot_->_updateAllRenderTargets();
+        ogreRoot_->_updateAllRenderTargets();
 
         uint64_t timeAfterTick = time.getRealMicroseconds();
Index: code/branches/core5/src/modules/objects/Planet.cc
===================================================================
--- code/branches/core5/src/modules/objects/Planet.cc	(revision 5924)
+++ code/branches/core5/src/modules/objects/Planet.cc	(revision 5925)
@@ -47,5 +47,5 @@
      * @brief Constructor
      */
-    Planet::Planet(BaseObject* creator): MovableEntity(creator)
+    Planet::Planet(BaseObject* creator) : MovableEntity(creator)
     {
         RegisterObject(Planet);
@@ -64,5 +64,5 @@
     void Planet::tick(float dt)
     {
-        if(!this->isVisible())
+        if (!this->isVisible())
             return;
 
@@ -70,5 +70,5 @@
         {
             Camera* activeCamera = CameraManager::getInstance().getActiveCamera();
-            if(activeCamera)
+            if (activeCamera)
             {
                 float distance = this->getPosition().distance( activeCamera->getWorldPosition() );
Index: code/branches/core5/src/orxonox/CameraManager.cc
===================================================================
--- code/branches/core5/src/orxonox/CameraManager.cc	(revision 5924)
+++ code/branches/core5/src/orxonox/CameraManager.cc	(revision 5925)
@@ -51,4 +51,5 @@
         : viewport_(GraphicsManager::getInstance().getViewport())
     {
+        assert(GameMode::showsGraphics());
     }
 
@@ -60,5 +61,5 @@
     Camera* CameraManager::getActiveCamera() const
     {
-        if (this->cameraList_.size() > 0)
+        if (!this->cameraList_.empty())
             return this->cameraList_.front();
         else
@@ -68,9 +69,6 @@
     void CameraManager::requestFocus(Camera* camera)
     {
-        if (!GameMode::showsGraphics())
-            assert(0);
-
         // notify old camera (if it exists)
-        if (this->cameraList_.size() > 0)
+        if (!this->cameraList_.empty())
             this->cameraList_.front()->removeFocus();
 
@@ -78,8 +76,9 @@
 
         // make sure we don't add it twice
-        for (std::list<Camera*>::iterator it = this->cameraList_.begin(); it != this->cameraList_.end(); ++it)
+        for (std::list<Camera*>::iterator it = this->cameraList_.begin(); it != this->cameraList_.end();)
             if ((*it) == camera)
-                return;
-
+                this->cameraList_.erase(it++);
+            else
+                ++it;
         // add to list
         this->cameraList_.push_front(camera);
@@ -88,7 +87,4 @@
     void CameraManager::releaseFocus(Camera* camera)
     {
-        if (!GameMode::showsGraphics())
-            assert(0);
-
         // notify the cam of releasing the focus
         if (!this->cameraList_.empty() && this->cameraList_.front() == camera)
@@ -98,5 +94,5 @@
 
             // set new focus if possible
-            if (this->cameraList_.size() > 0)
+            if (!this->cameraList_.empty())
                 this->cameraList_.front()->setFocus();
         }
Index: code/branches/core5/src/orxonox/graphics/Camera.cc
===================================================================
--- code/branches/core5/src/orxonox/graphics/Camera.cc	(revision 5924)
+++ code/branches/core5/src/orxonox/graphics/Camera.cc	(revision 5925)
@@ -38,4 +38,5 @@
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
+#include "core/GameMode.h"
 #include "core/GUIManager.h"
 #include "Scene.h"
@@ -50,4 +51,6 @@
         RegisterObject(Camera);
 
+        if (!GameMode::showsGraphics())
+            ThrowException(AbortLoading, "Can't create Camera, no graphics.");
         if (!this->getScene())
             ThrowException(AbortLoading, "Can't create Camera, no scene.");
@@ -76,6 +79,6 @@
         if (this->isInitialized())
         {
-            if( GUIManager::getInstance().getCamera() == this->camera_ )
-                GUIManager::getInstance().setCamera( NULL );
+            if (GUIManager::getInstance().getCamera() == this->camera_)
+                GUIManager::getInstance().setCamera(NULL);
             this->releaseFocus();
 