Index: branches/avi_play/src/lib/graphics/importer/Makefile.am
===================================================================
--- branches/avi_play/src/lib/graphics/importer/Makefile.am	(revision 5937)
+++ branches/avi_play/src/lib/graphics/importer/Makefile.am	(revision 5939)
@@ -11,5 +11,6 @@
                            texture.cc \
                            texture_sequence.cc \
-                           media_container.cc 
+                           media_container.cc \
+                           movie_player.cc
 
 
@@ -25,3 +26,4 @@
                  anorms.h \
                  anormtab.h \
-                 media_container.h 
+                 media_container.h \
+                 movie_player.h
Index: branches/avi_play/src/lib/graphics/importer/media_container.cc
===================================================================
--- branches/avi_play/src/lib/graphics/importer/media_container.cc	(revision 5937)
+++ branches/avi_play/src/lib/graphics/importer/media_container.cc	(revision 5939)
@@ -32,5 +32,5 @@
  * Default constructor
  */
-MediaContainer::MediaContainer()
+MediaContainer::MediaContainer(const char* filename)
 {
 
Index: branches/avi_play/src/lib/graphics/importer/media_container.h
===================================================================
--- branches/avi_play/src/lib/graphics/importer/media_container.h	(revision 5937)
+++ branches/avi_play/src/lib/graphics/importer/media_container.h	(revision 5939)
@@ -38,5 +38,5 @@
 public:
 
-  MediaContainer();
+  MediaContainer(const char* filename);
   ~MediaContainer();
 
Index: branches/avi_play/src/lib/graphics/importer/movie_player.cc
===================================================================
--- branches/avi_play/src/lib/graphics/importer/movie_player.cc	(revision 5939)
+++ branches/avi_play/src/lib/graphics/importer/movie_player.cc	(revision 5939)
@@ -0,0 +1,85 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: David Hasenfratz, Stephan Lienhard
+   co-programmer:
+*/
+
+
+
+/* this is for debug output. It just says, that all calls to PRINT() belong to the DEBUG_MODULE_MEDIA module
+   For more information refere to https://www.orxonox.net/cgi-bin/trac.cgi/wiki/DebugOutput
+*/
+#define DEBUG_MODULE_MEDIA
+
+
+/* include your own header */
+#include "movie_player.h"
+
+/* header for debug output */
+#include "debug.h"
+
+
+/**
+ * Default constructor
+ */
+MoviePlayer::MoviePlayer(const char* filename)
+{
+
+}
+
+/**
+ * Default destructor
+ */
+MoviePlayer::~MoviePlayer()
+{
+
+}
+
+void MoviePlayer::start(unsigned int start_frame)
+{
+
+}
+
+void MoviePlayer::resume()
+{
+
+}
+
+void MoviePlayer::pause()
+{
+
+}
+
+void MoviePlayer::stop()
+{
+
+}
+
+void MoviePlayer::tick(float time)
+{
+
+}
+
+const void MoviePlayer::draw()
+{
+
+}
+
+void MoviePlayer::setSpeed(float speed)
+{
+
+}
+
+float MoviePlayer::getSpeed()
+{
+
+}
Index: branches/avi_play/src/lib/graphics/importer/movie_player.h
===================================================================
--- branches/avi_play/src/lib/graphics/importer/movie_player.h	(revision 5939)
+++ branches/avi_play/src/lib/graphics/importer/movie_player.h	(revision 5939)
@@ -0,0 +1,55 @@
+/*!
+ * @file movie_player.h
+  *  Manages the media files
+
+*/
+
+#ifndef _MOVIE_PLAYER
+#define _MOVIE_PLAYER
+
+#include "glincl.h"
+#include "sdlincl.h"
+
+/* include base_object.h since all classes are derived from this one */
+#include "base_object.h"
+
+/* using namespace std is default, this needs to be here */
+using namespace std;
+
+class MoviePlayer : public BaseObject
+{
+
+private:
+
+	char* filename;
+	unsigned int width;
+	unsigned int height;
+
+	unsigned int frame_rate;
+	unsigned int current_frame;
+	float time_since_last_frame;
+	float speed;
+	
+	SDL_Surface* screen;
+
+public:
+
+  MoviePlayer(const char* filename);
+  ~MoviePlayer();
+
+	void start(unsigned int start_frame);
+	void resume();
+	void pause();
+	void stop();
+
+	void tick(float time);
+	const void draw();
+
+	void setSpeed(float speed);
+	float getSpeed();
+
+};
+
+
+
+#endif /* _MOVIE_PLAYER */